import java.io.*;

        // Compress multiple consecutive spaces to a single space.
class CompressSpaces {
    public static void main(String[] args) throws IOException {
        if(args.length == 1){
            FileReader reader = null;
            FileWriter writer = null;
            try{
                final String outputFile = "output.txt";
                // Use a File in order to find out the file's length.
                final File f = new File(args[0]);
                // Open the input and output files.
                reader = new FileReader(f);
                writer = new FileWriter(outputFile);
                // Attempt to read the whole file in a single read.
                final int fileSize = (int) f.length();
                // Allocate sufficient space.
                char[] buffer = new char [fileSize];

                if(fileSize != f.length()){
                    throw new IOException("File size mismatch.");
                }
                else if(reader.read(buffer,0,fileSize) != fileSize){
                    throw new IOException("Read failure.");
                }
                else{
                    // Keep track of whether or not we have found
                    // a space.
                    boolean spaceFound = false;
                    for(int i = 0; i < fileSize; i++){
                        if(Character.isSpaceChar(buffer[i])){
                            // Is this the first?
                            if(spaceFound){
                                // No, so don't copy it.
                            }
                            else{
                                // Yes, so copy it.
                                writer.write(buffer[i]);
                                spaceFound = true;
                            }
                        }
                        else{
                            writer.write(buffer[i]);
                            if(spaceFound){
                                // End of space run.
                                spaceFound = false;
                            }
                        }
                    }
                    writer.flush();
                }
            }
            finally{
                if(reader != null){
                    reader.close();
                }
                if(writer != null){
                    writer.close();
                }
            }
        }
        else{
           System.err.println("Usage: java CompressSpaces text-file");
        }
    }
}
