import java.io.*;

        // Calculate the percentage of letters in the text file
        // passed as program argument.
class LetterPercentage {
    public static void main(String[] args) {
        if(args.length == 1){
            FileReader reader = null;
            try{
                // Use a File in order to find out the file's length.
                final File f = new File(args[0]);
                // Open the input file.
                reader = new FileReader(f);
                // Attempt to read the whole file in a single read.
                final int fileSize = (int) f.length();
                // Allocate sufficient space.
                char[] buffer = new char [fileSize];

                if(fileSize != f.length()){
                    throw new IOException("File size mismatch.");
                }
                else if(reader.read(buffer,0,fileSize) != fileSize){
                    throw new IOException("Read failure.");
                }
                else{
                    int letterCount = 0;
                    for(int i = 0; i < fileSize; i++){
                        if(Character.isLetter(buffer[i])){
                            letterCount++;
                        }
                    }
                    if(fileSize > 0){
                        System.out.println("The percentage of letters is: "+
                                           100.0*letterCount/fileSize);
                    }
                    else{
                        System.out.println("The file is empty.");
                    }
                }
                reader.close();
            }
            catch(IOException e){
                System.err.println("File processing failure: "+
                                   e.getMessage());
            }
        }
        else{
            System.err.println("Usage: java LetterPercentage text-file");
        }
    }
}
