        // A test rig for the Polygon class, which overrides
        // the equals and toString methods of Object.
        // Polygons should match even with rotated orderings
        // of their points.
class PolygonMain {
    public static void main(String[] args){
        final Point[] p1Points = new Point[] {
            new Point(0,0),
            new Point(0,2),
            new Point(2,3),
            new Point(3,1),
            new Point(2,0),
        };
        final Polygon pentangle1 = new Polygon(p1Points);
        // In order to demonstrate the revised equals method,
        // rotate the pentangle points.
        Point[] p2Points = new Point[p1Points.length];
        System.arraycopy(p1Points,1,p2Points,0,
                         p1Points.length-1);
        p2Points[p1Points.length-1] = p1Points[0];
        Polygon pentangle2 = new Polygon(p2Points);

        final Polygon square = new Polygon(new Point[]{
            new Point(0,0), new Point(0,1),
            new Point(1,1), new Point(1,0),
        });

        // Demonstrate the toString method.
        System.out.println("Pentangle 1: "+pentangle1);
        System.out.println("Pentangle 2: "+pentangle2);
        System.out.println("Square: "+square);

        if(pentangle1.equals(pentangle2)){
            System.out.println("Pentangles match.");
        }

        if(pentangle2.equals(square)){
            System.err.println("Pentangle matches the square!");
        }
    }
}
