        // A test class for the PresetsRadio class.
class PresetsRadioMain {
    public static void main(String[] args){
        try{
            double[] frequencies = {
                Radio.MIN_FREQUENCY+10000000.0,
                Radio.MIN_FREQUENCY+20000000.0,
                Radio.MIN_FREQUENCY+30000000.0,
                Radio.MIN_FREQUENCY,
            };

            PresetsRadio radio1 = new PresetsRadio(frequencies);
            System.out.println("The initial frequency is: "+
                               radio1.getFrequency());
            // Move up and down the presets.
            final int numPresets = frequencies.length;
            for(int i = 0; i < numPresets; i++){
                radio1.stationUp();
                System.out.println("The next frequency up is: "+
                                   radio1.getFrequency());
            }
            for(int i = 0; i < numPresets; i++){
                radio1.stationDown();
                System.out.println("The next frequency down is: "+
                                   radio1.getFrequency());
            }

            // Try using an invalid frequency.
            System.out.println("Changing the presets.");
            frequencies[1] = Radio.MIN_FREQUENCY-10000000.0;
            System.out.println("The current frequency is: "+
                               radio1.getFrequency());
            radio1.setPresets(frequencies);
            radio1.stationUp();
            System.out.println("The next frequency up is: "+
                               radio1.getFrequency());
        }
        catch(RuntimeException e){
            System.err.println(e.getMessage());
        }
    }
}
