import java.util.Random;

        // Support delivery of random numbers within a
        // [lower ... upper] range.
class RandomRange {
    public RandomRange(int lower,int upper) throws RandomRangeException {
        if(lower <= upper){
             this.lower = lower;
             this.upper = upper;
             this.range = upper-lower+1;
        }
        else{
             throw new RandomRangeException(
                "Lower limit "+lower+" exceeds upper: "+upper);
        }
    }

        // The lower bound is zero.
    public RandomRange(int upper) throws RandomRangeException {
        this(0,upper);
    }

        // Return the next random range in the range [lower ... upper].
    public int next(){
        int value = getRand().nextInt(getRange());
        return value+getLower();
    }

    protected int getLower(){
        return lower;
    }

    protected int getUpper(){
        return upper;
    }

    protected int getRange(){
        return range;
    }

    private Random getRand(){
        return rand;
    }

    private final int lower, upper;
    // A convenience value. This should always be: upper-lower+1
    private final int range;
    // All instances can share the same random number generator.
    private static final Random rand = new Random();
}
