import java.util.*;

        // Iterate over an array of objects.
        // Do not return null items from the array.
class ArrayIterator1 implements Iterator {
        // Retain a reference to the data to be iterated over.
    public ArrayIterator1(Object[] data){
        array = data;
    }

        // Definitions of the interface methods.
    public boolean hasNext(){
        return nextValidIndex() >= 0;
    }

    public Object next() throws NoSuchElementException {
        if(hasNext()){
            int index = nextValidIndex();
            // Update the value for next time.
            setLastIndex(index);
            return getArray()[index];
        }
        else{
            throw new NoSuchElementException();
        }
    }

        // Remove an element by setting it to null.
    public void remove() throws IllegalStateException,
                                UnsupportedOperationException {
        int index = getLastIndex();
        if(index < 0){
            throw new IllegalStateException();
        }
        else{
            getArray()[index] = null;
        }
    }

        // Find the index of the next non-null item in the array.
        // Start looking from lastIndex+1. Return -1 if there
        // is no next item.
    private int nextValidIndex(){
        Object[] array = getArray();
        final int numItems = array.length;
        int index = getLastIndex()+1;
        while((index < numItems) && (array[index] == null)){
            index++;
        }
        if(index < numItems){
            return index;
        }
        else{
            return -1;
        }
    }

        // Accessors and mutators for the lastIndex and array attributes.
    private int getLastIndex(){
        return lastIndex;
    }

    private void setLastIndex(int n){
        lastIndex = n;
    }

    private Object[] getArray(){
        return array;
    }

    // The array of objects to be iterated over.
    private final Object[] array;
    // The index of the last element returned.
    private int lastIndex = -1;
}
