import java.io.*;

        // A simple implementation of the Logger interface.
        // Log messages to a named file.
class FileLogger implements Logger {
    public FileLogger(String filename) throws IOException {
        this.writer = new BufferedWriter(new FileWriter(filename));
    }

    public void report(String message){
        try{
            BufferedWriter writer = getWriter();
            writer.write(message);
            writer.newLine();
        }
        catch(IOException e){
            System.err.println("Failed to write: "+message);
        }
    }

    public void close() throws IOException {
        getWriter().close();
    }

    private BufferedWriter getWriter(){
        return writer;
    }

    private final BufferedWriter writer;
}
